import numpy as np

D = np.loadtxt( "datos.txt" )
# print( D.shape )

#
np.random.seed(3)

eta = 0.1

#  Para cada neurona es un vector [w1, w2, 1]^T
# P1 = 0.02*np.random.randn( 3, 2 )   # Dos neuronas de entrada
# P2 = 0.02*np.random.randn( 3, 2 )   # Dos neuronas de salida

# P1 = np.zeros( (3, 2) )   # Dos neuronas de entrada
# P2 = np.zeros( (3, 2) )   # Dos neuronas de salida

# Los pesos del ejemplo del libro de Gonzalez y Woods:
# P1 = np.array( [ [ 4.792, 4.792 ],
#                    [ 4.486, 4.486 ],
#                  [ 4.590,-4.486 ] ] )
 
#P2 = np.array( [ [ -9.180, 9.429 ],
#                  [  9.178, -9.427 ],
#                  [  4.420, -4.419 ] ] )

# Los pesos entrenados con sklearn con el quasi Newton

# P1 = np.array( [[-6.31413356, -4.97323625],
#                 [-5.92987893, -4.74312505],
#                 [ 8.24884715, -5.81598493]] )

# P2 = np.array( [[-16.11614659,  16.24816522],
#                 [ 15.17554471, -16.93096011],
#                 [ 8.48314319, -8.2828667 ]]  )

# Pesos entrenados en sklearn con el optimizador adam
# (2, 10)
P1 = np.array( [[-2.51308377,  2.66043392, -3.05976548, -2.70258681, -2.46228654, -2.86598656,
                 -2.6513191 , -2.64846383, -2.74459823,  2.33557156],
                [-2.6764421 , -2.55588098, -2.38113585,  2.7841293 , -2.93826655,  2.73016835,
                  2.48727506,  2.57667126, -2.41746227, -2.25822232]] )
# (10, 2)
P2 = np.array( [[-3.06105677,  2.7230422 ],
                [ 2.24249564, -2.10824519],
                [ 2.8407337 , -2.85436972],
                [ 3.06277118, -2.68257002],
                [-2.92151736,  2.79918316],
                [ 3.08534531, -2.54956986],
                [-2.75643889,  2.80700598],
                [-2.84195187,  2.46761067],
                [ 3.09555147, -2.90761656],
                [ 1.15555645, -1.2640728 ]] )

S1 = np.array( [ 2.81305406,  3.0702667 , -2.6157884 ,  2.70725998,  2.69032236,
                 2.7427792 , -2.9934746 , -3.04006139, -2.76124895,  2.92540865] )

S2 = np.array( [-3.03309609,  2.83784278] )


# Para guardar 
Z1 = np.zeros( (1,10) )
A1 = np.zeros( (1,10) )

Z2 = np.zeros( (1,2) )
A2 = np.zeros( (1,2) )

vv = np.zeros( (1,2) )

def sigmoide( x ) :
	return 1.0/(1.0+np.exp(-x))

# La entrada debe ser un vector de tamaño (1,3)
# el último debe ser igual a 1 (para representar el sesgo)
def hacia_adelante( Entradas ) : 

	# Realizamos los cálculos en la primera capa
	#      1x2      2x10 = 1x10    
	Z1 = Entradas @ P1 + S1 

	A1[0,:] = sigmoide( Z1 )

	###########################
	#    1x10  10x2  = 1x2
	Z2 = A1 @ P2 + S2 
	A2[0,0:2] = sigmoide( Z2 )

	return A2[0,0], A2[0,1]

def calcula_error( ) :
	error = 0.0

	j = 0
	while j < 900 :
		vv[0,:] = [ D[j,0], D[j,1] ]
		s1, s2 = hacia_adelante( vv )
		k1 = D[j,2] - A2[0,0] 
		a = 1
		if D[j,2] > 0.5 :
			a = 0
		k2 = a - A2[0,1]
		# print( "ks:", k1, k2 ) 
		error += k1*k1 + k2*k2
		j += 1
	
	return np.sqrt( error/1800 )

def calcula_error_dos( ) :
	error = 0.0

	j = 0
	while j < 900 :
		vv[0,:] = [ D[j,0], D[j,1] ]
		s1, s2 = hacia_adelante( vv )
		k = s1-D[j,2]
		print( D[j,0], D[j,1], s1, s2 )
		error += k*k
		j += 1
	
	return np.sqrt(error/900)

# Entrenamiendo

error = calcula_error( )
print( 0, error )

# print( P1 )
# print( P2 )

calcula_error_dos( )
